<?php
/**
* @license GNU/GPL, see LICENSE.php
* Site: www.shape5.com
* Email: contact@shape5.com
* @copyright (C) 2009 Shape 5
*
*/

jimport('joomla.application.component.controller');

/**
 * s5_clan_roster Component Controller
 *
 * @package    s5_clan_roster
 * @subpackage Components
 */
class S5ClanRosterController extends JController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct()
	{
		parent::__construct();
		// Register Extra tasks
		$this->registerTask( 'apply','save' );
		$this->registerTask( 'unpublish', 'publish' );
		$this->registerTask( 'orderdown', 'order' );
		$this->registerTask( 'orderup', 'order' );			
		$this->registerTask( 'copyselect', 'copy' );	
	}
	
	/**
	 * display 
	 * @return void
	 */
	function display(){
		JRequest::setVar( 'view', 's5clanroster' );
		JRequest::setVar( 'layout', 'default'  );
		//JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}
	
	/**
	 * html  for add new category
	 * @return void
	 */	
	function add(){
		$model 	=& $this->getModel( 's5clanroster' );
		$view 	=& $this->getView( 's5clanroster', '.html' );
		$view->setModel( $model, true );
		$view->add();
	}	
	
	/**
	 * html  for copy category
	 * @return void
	 */	
	function copy(){
		$model 	=& $this->getModel( 's5clanroster' );
		$view 	=& $this->getView( 's5clanroster', '.html' );
		$view->setModel( $model, true );
		$view->copy();
	}		
	
	/**
	 * return to main component
	 *
	 */
	function cancel() {
		$this->setRedirect('index.php?option=com_s5clanroster&view=s5clanroster');
	}	
	
	/**
	 * save new category
	 * @return void
	 */	
	function save(){
	
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );	
	
		$model =& $this->getModel('s5clanroster');
		$msg = $model->save();
		
		if(JRequest::getVar('task') == 'apply'){
			$db	=& JFactory::getDBO();
			if($db->insertId()){
				$cid = $db->insertId();
			}else{
				$cid = JRequest::getVar( 'id' );			
			}
			$this->setRedirect('index.php?option=com_s5clanroster&task=edit&cid[]='.$cid);
		}else{
			$this->setRedirect('index.php?option=com_s5clanroster&view=s5clanroster',$msg);
		}
	}
	
	/**
	 * save a copy category
	 * @return void
	 */	
	function savecopy(){
	
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );	
	
		$model =& $this->getModel('s5clanroster');
		$msg = $model->savecopy();
		
		$this->setRedirect('index.php?option=com_s5clanroster&view=s5clanroster',$msg);
	}			

	/**
	 * delete a listing
	 * @return void
	 */	
	function remove(){
		$model =& $this->getModel('s5clanroster');
		$msg = $model->delete();
		
		$this->setRedirect('index.php?option=com_s5clanroster&view=s5clanroster',$msg);
	}
	
	/**
	 * edit listing
	 *
	 */
	function edit() {
		$model 	=& $this->getModel( 's5clanroster' );
		$view 	=& $this->getView( 's5clanroster', '.html' );
		$view->setModel( $model, true );
		$view->edit();
	}
	
	/**
	 * publish or unpubish listings
	 *
	 */
	function publish() {
		$model =& $this->getModel( 's5clanroster' );
		$task = JRequest::getCmd('task');
		if ($task == 'publish') {
			$model->publish(1);
		} elseif ($task == 'unpublish') {
			$model->publish(0);
		} 
		
		$this->setRedirect('index.php?option=com_s5clanroster&view=s5clanroster');
	}	
	
	/**
	 * Method order up(-1)/down(1) a listing with one record
	 *
	 * $ordering = int current ordering value
	 * $uid		 = int moved category id
	 * $inc		 = int up(-1)/down(1)
	 *
	 * @access	public
	 * @return	boolean	True on success
	 */	
	function order(){
		global $mainframe;
		$model =& $this->getModel('s5clanroster');
		$msg = $model->order();		
		
		$limit		= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart	= $mainframe->getUserStateFromRequest('limitstart', 'limitstart', 0, 'int');

		$link = 'index.php?option=com_s5clanroster&view=s5clanroster&limitstart='.$limitstart.'&limit='.$limit;
		$this->setRedirect($link, $msg);			
		
		return true;		
	}
	
	/**
	 * Method to save new order a listing 
	 *
	 * $ordering = int current ordering value
	 * $uid		 = int moved category id
	 * $inc		 = int up(-1)/down(1)
	 *
	 * @access	public
	 * @return	boolean	True on success
	 */	
	function saveorder(){
		global $mainframe;
		$model =& $this->getModel('s5clanroster');
		$msg = $model->saveorder();		
		
		$limit		= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart	= $mainframe->getUserStateFromRequest('limitstart', 'limitstart', 0, 'int');

		$link = 'index.php?option=com_s5clanroster&view=s5clanroster&limitstart='.$limitstart.'&limit='.$limit;
		$this->setRedirect($link, $msg);			
		
		return true;		
	}	

}
?>
