<?php
/**
 * Helpers tmpl for S5ClanRoster Component
 * 
 * @package    
 * @subpackage Components
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die(); 

jimport('joomla.application.component.model');

class S5ClanRosterHelpers {


	/**
	 * Build the select list for parent menu item
	 */
	function Parent( &$row = '' )
	{
		$db =& JFactory::getDBO();

		// If a not a new item, lets set the menu item id
		if ( isset($row->id) ) {
			$id = ' AND id != '.(int) $row->id;
		} else {
			$id = null;
		}

		// In case the parent was null
		if (!isset($row->parent)) {
			$row->parent = 0;
		}

		// get a list of the menu items
		// excluding the current menu item and its child elements
		$query = 'SELECT m.*' .
				' FROM #__s5clanroster_categories m' .
				' WHERE 1 ' .
				$id .
				' ORDER BY parent, ordering';
		$db->setQuery( $query );
		$mitems = $db->loadObjectList();
		//generate error msg		
		if ($db->getErrorNum()) {
			echo $db->stderr();
			exit;
		}
		
		// establish the hierarchy of the menu
		$children = array();

		if ( $mitems )
		{
			// first pass - collect children
			foreach ( $mitems as $v )
			{
				$pt 	= $v->parent;
				$list 	= @$children[$pt] ? $children[$pt] : array();
				array_push( $list, $v );
				$children[$pt] = $list;
			}
		}

		// second pass - get an indent list of the items
		$list = JHTML::_('menu.treerecurse', 0, '', array(), $children, 2, 0, 0 );

		// assemble menu items to the array
		$mitems 	= array();
		$mitems[] 	= JHTML::_('select.option',  '0', JText::_( 'Top' ) );

		foreach ( $list as $item ) {
			$mitems[] = JHTML::_('select.option',  $item->id, '&nbsp;&nbsp;&nbsp;'. $item->treename );
		}

		$output = JHTML::_('select.genericlist',   $mitems, 'parent', 'class="inputbox" size="10" onclick="check_parent(this)"', 'value', 'text', $row->parent );

		return $output;
	}
	
	/**
	 * Build the select list for parent menu item
	 */
	function User_Category( $row )
	{
		$db =& JFactory::getDBO();

		// get a list of the menu items
		// excluding the current menu item and its child elements
		$query = 'SELECT m.*' .
				' FROM #__s5clanroster_categories m' .
				' ORDER BY parent, ordering';
		$db->setQuery( $query );
		$mitems = $db->loadObjectList();
		//generate error msg		
		if ($db->getErrorNum()) {
			echo $db->stderr();
			exit;
		}
		
		// establish the hierarchy of the menu
		$children = array();
		$selected = array();

		if ( $mitems )
		{
			// first pass - collect children
			foreach ( $mitems as $v ){
				$pt 	= $v->parent;
				$list 	= @$children[$pt] ? $children[$pt] : array();
				array_push( $list, $v );
				$children[$pt] = $list;
				//generate selected
				if($row > 0){
					$assign_users = explode(",",$v->user_id);
					if(in_array($row,$assign_users)){
						$selected[] = $v->id;
					}
				}
			}
		}

		// second pass - get an indent list of the items
		$list = JHTML::_('menu.treerecurse', 0, '', array(), $children, 2, 0, 0 );

		// assemble menu items to the array
		$mitems 	= array();

		foreach ( $list as $item ) {
			$mitems[] = JHTML::_('select.option',  $item->id, '&nbsp;&nbsp;&nbsp;'. $item->treename );
		}

		$output = JHTML::_('select.genericlist',   $mitems, 'category[]', 'class="inputbox" size="10" onclick="loopSelected('.$row.');" multiple="multiple"', 'value', 'text', $selected);

		return $output;
	}	
	
	/**
	 * Build the select list for child menu item
	 */
	function Child( $selected = '' )
	{
		$db =& JFactory::getDBO();

		// If a not a new item, lets set the menu item id
		if ( isset($row->id) ) {
			$id = ' AND id != '.(int) $row->id;
		} else {
			$id = null;
		}

		// get a list of the menu items
		// excluding the current menu item and its child elements
		$query = 'SELECT m.*' .
				' FROM #__yj_directory_categories m' .
				' WHERE 1 ' .
				$id .
				' ORDER BY parent, ordering';
		$db->setQuery( $query );
		$mitems = $db->loadObjectList();

		// establish the hierarchy of the menu
		$children = array();

		if ( $mitems )
		{
			// first pass - collect children
			foreach ( $mitems as $v )
			{
				$pt 	= $v->parent;
				$list 	= @$children[$pt] ? $children[$pt] : array();
				array_push( $list, $v );
				$children[$pt] = $list;
			}
		}

		// second pass - get an indent list of the items
		$list = JHTML::_('menu.treerecurse', 0, '', array(), $children, 9999, 0, 0 );

		// assemble menu items to the array
		$mitems 	= array();

		foreach ( $list as $item ) {
			//if($item->parent == 0)
			//	$mitems[] = JHTML::_('select.option',  $item->id, '&nbsp;&nbsp;&nbsp;'. $item->treename, 'value', 'text', true);
			//else
				$mitems[] = JHTML::_('select.option',  $item->id, '&nbsp;&nbsp;&nbsp;'. $item->treename );			
		}

		$output = JHTML::_('select.genericlist',   $mitems, 'category_id', 'class="inputbox" size="10"', 'value', 'text', $selected );

		return $output;
	}	
	
	//upload photo
	function add_photo($photo_name,$user_id){
		global $mainframe;
		$mosConfig_absolute_path = JPATH_ROOT;
		$mosConfig_live_site = JURI :: base();
		$db =& JFactory::getDBO();
		$return = array("image"=>"","error"=>"");
		
		if(!is_dir(JPATH_ROOT.DS."images".DS."stories".DS."s5clanroster_photos")) mkdir(JPATH_ROOT.DS."images".DS."stories".DS."s5clanroster_photos", 0777);
		
		//check the photo extension, only jpg,gif,png
		$image_info = pathinfo($_FILES["user_photo"]['name']);
		//verify image type
		$allow_type_image = array('jpg','gif','png');
		if(!in_array(strtolower($image_info['extension']),$allow_type_image)){
			$mainframe->enqueueMessage(JText::_("ERROR PHOTO TYPE"), 'error');
			return false;
		}else{		
			$img_size = @getimagesize($_FILES["user_photo"]['tmp_name']);
			$width_old = $img_size[0];
			$height_old = $img_size[1];	
				
			//get thumb width and height
			$sql = "SELECT * "
			."\n FROM `#__s5clanroster_settings` "
			."\n WHERE id = '1'";
			$db->setQuery($sql);
			$settings = $db->loadObjectList();	
			$width_2  =	$settings[0]->user_photo_width  ? $settings[0]->user_photo_width  : "100";
			$height_2 =	$settings[0]->user_photo_height ? $settings[0]->user_photo_height : "100";		
			
			if(!isset($gdimg) || !$gdimg){
				$gdimg = imagecreatefromjpeg($_FILES["user_photo"]['tmp_name']);
				$ext = "jpg";
			}
			if(!isset($gdimg) || !$gdimg){
				$gdimg = imagecreatefromgif($_FILES["user_photo"]['tmp_name']);
				$ext = "gif";
			}
			if(!isset($gdimg) || !$gdimg){
				$gdimg = imagecreatefrompng($_FILES["user_photo"]['tmp_name']);
				$ext = "png";
			}
			if(!isset($gdimg) || !$gdimg){
				$mainframe->enqueueMessage(JText::_("ERROR CREATE THUMB"), 'error');		
				return false;
			}
			
			//create image regenerated
			if($ext!='gif'){
				$image_p = imagecreatetruecolor($width_2,$height_2);
				$trans = imagecolorallocate($image_p,0,0,0);
				imagecolortransparent($image_p,$trans);			
				imagecopyresampled($image_p, $gdimg, 0, 0, 0, 0, $width_2, $height_2, $width_old, $height_old);
			}else{
				$image_p = imagecreate($width_2,$height_2);
				$trans = imagecolorallocate($image_p,0,0,0);
				imagecolortransparent($image_p,$trans);					
				imagecopyresized($image_p, $gdimg, 0, 0, 0, 0, $width_2, $height_2, $width_old, $height_old);				
			}
			
			//put image on the folder with th_ in front of image name
			$name = $photo_name.".".$ext;
			$name = str_replace(" ","_",$name);
			$name = str_replace("-","_",$name);
			 //check if we already have a image with this name
			 if(file_exists(JPATH_ROOT.DS."images".DS."stories".DS."s5clanroster_photos".DS.$name)){
			 	@unlink(JPATH_ROOT.DS."images".DS."stories".DS."s5clanroster_photos".DS.$name);
				//$mainframe->enqueueMessage(JText::_("PHOTO NAME EXISTS"), 'error');			
				//return false;
			 }
			 
			 if($ext == "jpg") $upload_th = imagejpeg($image_p, $mosConfig_absolute_path.'/images/stories/s5clanroster_photos/'.$name, 70);
			 if($ext == "gif") $upload_th = imagegif($image_p, $mosConfig_absolute_path.'/images/stories/s5clanroster_photos/'.$name, 70);
			 if($ext == "png") $upload_th = imagepng($image_p, $mosConfig_absolute_path.'/images/stories/s5clanroster_photos/'.$name, 7);
			 @chmod($mosConfig_absolute_path.'/images/stories/s5clanroster_photos/'.$name, 0755);			 
			//if resize return new thumb name
			if($upload_th){
				$return["image"] = $name;
				return $return;
			}else{
				$mainframe->enqueueMessage(JText::_("ERROR UPLOAD PHOTO"), 'error');			
				return false;		
			}
		}
	}	
}
?>