<?php
/**
 * Helpers tmpl for S5ClanRoster Component
 * 
 * @package    
 * @subpackage Components
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die(); 

jimport('joomla.application.component.model');

class S5ClanRosterHelpers {

	//upload photo
	function add_photo($photo_name,$user_id){
		global $mainframe;
		$mosConfig_absolute_path = JPATH_ROOT;
		$mosConfig_live_site = JURI :: base();
		$db =& JFactory::getDBO();
		$return = array("image"=>"","error"=>"");
		
		if(!is_dir(JPATH_ROOT.DS."images".DS."stories".DS."s5clanroster_photos")) mkdir(JPATH_ROOT.DS."images".DS."stories".DS."s5clanroster_photos", 0777);
		
		//check the photo extension, only jpg,gif,png
		$image_info = pathinfo($_FILES["user_photo"]['name']);
		//verify image type
		$allow_type_image = array('jpg','gif','png');
		if(!in_array(strtolower($image_info['extension']),$allow_type_image)){
			$mainframe->enqueueMessage(JText::_("ERROR PHOTO TYPE"), 'error');
			return false;
		}else{		
			$img_size = @getimagesize($_FILES["user_photo"]['tmp_name']);
			$width_old = $img_size[0];
			$height_old = $img_size[1];	
				
			//get thumb width and height
			$sql = "SELECT * "
			."\n FROM `#__s5clanroster_settings` "
			."\n WHERE id = '1'";
			$db->setQuery($sql);
			$settings = $db->loadObjectList();	
			$width_2  =	$settings[0]->user_photo_width  ? $settings[0]->user_photo_width  : "100";
			$height_2 =	$settings[0]->user_photo_height ? $settings[0]->user_photo_height : "100";		
			
			if(!isset($gdimg) || !$gdimg){
				$gdimg = imagecreatefromjpeg($_FILES["user_photo"]['tmp_name']);
				$ext = "jpg";
			}
			if(!isset($gdimg) || !$gdimg){
				$gdimg = imagecreatefromgif($_FILES["user_photo"]['tmp_name']);
				$ext = "gif";
			}
			if(!isset($gdimg) || !$gdimg){
				$gdimg = imagecreatefrompng($_FILES["user_photo"]['tmp_name']);
				$ext = "png";
			}
			if(!isset($gdimg) || !$gdimg){
				$mainframe->enqueueMessage(JText::_("ERROR CREATE THUMB"), 'error');		
				return false;
			}
			
			//create image regenerated
			if($ext!='gif'){
				$image_p = imagecreatetruecolor($width_2,$height_2);
				$trans = imagecolorallocate($image_p,0,0,0);
				imagecolortransparent($image_p,$trans);			
				imagecopyresampled($image_p, $gdimg, 0, 0, 0, 0, $width_2, $height_2, $width_old, $height_old);
			}else{
				$image_p = imagecreate($width_2,$height_2);
				$trans = imagecolorallocate($image_p,0,0,0);
				imagecolortransparent($image_p,$trans);					
				imagecopyresized($image_p, $gdimg, 0, 0, 0, 0, $width_2, $height_2, $width_old, $height_old);				
			}
			
			//put image on the folder with th_ in front of image name
			$name = $photo_name.".".$ext;
			$name = str_replace(" ","_",$name);
			$name = str_replace("-","_",$name);
			//check if we already have a image with this name
			if(file_exists(JPATH_ROOT.DS."images".DS."stories".DS."s5clanroster_photos".DS.$name)){
			 	@unlink(JPATH_ROOT.DS."images".DS."stories".DS."s5clanroster_photos".DS.$name);			
				//$mainframe->enqueueMessage(JText::_("PHOTO NAME EXISTS"), 'error');			
				//return false;
			}
			 
			 if($ext == "jpg") $upload_th = imagejpeg($image_p, $mosConfig_absolute_path.'/images/stories/s5clanroster_photos/'.$name, 70);
			 if($ext == "gif") $upload_th = imagegif($image_p, $mosConfig_absolute_path.'/images/stories/s5clanroster_photos/'.$name, 70);
			 if($ext == "png") $upload_th = imagepng($image_p, $mosConfig_absolute_path.'/images/stories/s5clanroster_photos/'.$name, 7);
			 @chmod($mosConfig_absolute_path.'/images/stories/s5clanroster_photos/'.$name, 0755);			 
			//if resize return new thumb name
			if($upload_th){
				$return["image"] = $name;
				return $return;
			}else{
				$mainframe->enqueueMessage(JText::_("ERROR UPLOAD PHOTO"), 'error');			
				return false;		
			}
		}
	}	
}

class S5Pathway extends JObject
{
	/**
	 * Array to hold the pathway item objects
	 * @access private
	 */
	var $_pathway = null;

	/**
	 * Integer number of items in the pathway
	 * @access private
	 */
	var $_count = 0;

	/**
	 * Class constructor
	 */
	function __construct($options = array())
	{
		//Initialise the array
		$this->_pathway = array();
	}

	/**
	 * Returns a reference a JPathway object
	 *
	 * This method must be invoked as:
	 * 		<pre>  $menu = &JPathway::getInstance();</pre>
	 *
	 * @access	public
	 * @param   string  $client  The name of the client
	 * @param array     $options An associative array of options
	 * @return JPathway 	A pathway object.
	 * @since	1.5
	 */
	function &getInstance($client, $options = array())
	{
		static $instances;

		if (!isset( $instances )) {
			$instances = array();
		}

		if (empty($instances[$client]))
		{
			//Load the router object
			$info =& JApplicationHelper::getClientInfo($client, true);

			$path = $info->path.DS.'includes'.DS.'pathway.php';
			if(file_exists($path))
			{
				require_once $path;

				// Create a JPathway object
				$classname = 'JPathway'.ucfirst($client);
				$instance = new $classname($options);
			}
			else
			{
				$error = JError::raiseError( 500, 'Unable to load pathway: '.$client);
				return $error;
			}

			$instances[$client] = & $instance;
		}

		return $instances[$client];
	}

	/**
	 * Return the JPathWay items array
	 *
	 * @access public
	 * @return array Array of pathway items
	 * @since 1.5
	 */
	function getPathway()
	{
		$pw = $this->_pathway;

		// Use array_values to reset the array keys numerically
		return array_values($pw);
	}

	/**
	 * Set the JPathway items array.
	 *
	 * @access	public
	 * @param	array	$pathway	An array of pathway objects.
	 * @return	array	The previous pathway data.
	 * @since	1.5
	 */
	function setPathway($pathway)
	{
		$oldPathway	= $this->_pathway;
		$pathway	= (array) $pathway;

		// Set the new pathway.
		$this->_pathway = array_values($pathway);

		return array_values($oldPathway);
	}

	/**
	 * Create and return an array of the pathway names.
	 *
	 * @access public
	 * @return array Array of names of pathway items
	 * @since 1.5
	 */
	function getPathwayNames()
	{
		// Initialize variables
		$names = array (null);

		// Build the names array using just the names of each pathway item
		foreach ($this->_pathway as $item) {
			$names[] = $item->name;
		}

		//Use array_values to reset the array keys numerically
		return array_values($names);
	}

	/**
	 * Create and add an item to the pathway.
	 *
	 * @access public
	 * @param string $name
	 * @param string $link
	 * @return boolean True on success
	 * @since 1.5
	 */
	function addItem($name, $link='')
	{
		// Initalize variables
		$ret = false;

		if ($this->_pathway[] = $this->_makeItem($name, $link)) {
			$ret = true;
			$this->_count++;
		}

		return $ret;
	}

	/**
	 * Set item name.
	 *
	 * @access public
	 * @param integer $id
	 * @param string $name
	 * @return boolean True on success
	 * @since 1.5
	 */
	function setItemName($id, $name)
	{
		// Initalize variables
		$ret = false;

		if (isset($this->_pathway[$id])) {
			$this->_pathway[$id]->name = $name;
			$ret = true;
		}

		return $ret;
	}

	/**
	 * Create and return a new pathway object.
	 *
	 * @access private
	 * @param string $name Name of the item
	 * @param string $link Link to the item
	 * @return object Pathway item object
	 * @since 1.5
	 */
	function _makeItem($name, $link)
	{
		$item = new stdClass();
		$item->name = html_entity_decode($name);
		$item->link = $link;

		return $item;
	}
}
?>